<template>
  <div>
    <Form :handleSubmit=handleSubmit :error=error>
      <label for="hash">Your hash</label>
      <input id="hash" type="text" placeholder="Type your hash here" required v-model=hash />
    </Form>
    <p v-if="decryptedHash.secretText">Your secret: <strong>{{decryptedHash.secretText}}</strong></p>
  </div>
</template>

<script>
  import { mapState, mapActions } from 'vuex';
  import Form from '../components/Form';

  export default {
    name: 'GetSecretContainer',
    components: { Form },
    data () {
      return { hash: '' };
    },
    computed: mapState({
      error: state => state.error,
      encryptedHashes: state => state.encryptedHashes,
      decryptedHash: state => state.decryptedHash
    }),
    methods: {
      ...mapActions(['getSecret']),
      async handleSubmit (evt) {
        evt.preventDefault();

        await this.getSecret(this.hash);

        this.hash = '';
      },
    }
  }
  </script>
